var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _HihglightOverlay_instances, _HihglightOverlay_context, _HihglightOverlay_elements, _HihglightOverlay_params, _HihglightOverlay_cursor, _HihglightOverlay_mouseHandler, _HihglightOverlay_draw, _HihglightOverlay_updateCursor, _HihglightOverlay_handleClick;
import MouseHandler from './MouseHandler';
import BackDropContext from './BackDropContext';
import { isVisible } from './utils/isVisible';
import { CloseTypes } from './interfaces/enums';
const defaultOptions = {
    offset: 3,
    close: CloseTypes.ALWAYS,
    backDropColor: [0, 0, 0, 0.3],
    cursor: {
        enabled: false,
        size: 15,
    },
};
class HihglightOverlay {
    constructor(params) {
        _HihglightOverlay_instances.add(this);
        _HihglightOverlay_context.set(this, void 0);
        _HihglightOverlay_elements.set(this, void 0);
        _HihglightOverlay_params.set(this, void 0);
        _HihglightOverlay_cursor.set(this, void 0);
        _HihglightOverlay_mouseHandler.set(this, void 0);
        __classPrivateFieldSet(this, _HihglightOverlay_context, new BackDropContext(), "f");
        __classPrivateFieldSet(this, _HihglightOverlay_params, { ...defaultOptions, ...params, cursor: { ...defaultOptions.cursor, ...params?.cursor } }, "f");
        __classPrivateFieldSet(this, _HihglightOverlay_elements, [], "f");
        __classPrivateFieldSet(this, _HihglightOverlay_cursor, { x: 0, y: 0 }, "f");
        __classPrivateFieldSet(this, _HihglightOverlay_mouseHandler, new MouseHandler({
            cursorMonitoring: __classPrivateFieldGet(this, _HihglightOverlay_params, "f").cursor.enabled,
            onMove: __classPrivateFieldGet(this, _HihglightOverlay_instances, "m", _HihglightOverlay_updateCursor).bind(this),
            onClick: __classPrivateFieldGet(this, _HihglightOverlay_instances, "m", _HihglightOverlay_handleClick).bind(this),
        }), "f");
    }
    show(elements) {
        __classPrivateFieldSet(this, _HihglightOverlay_elements, [], "f");
        for (let i = 0; i < elements.length; i++) {
            const element = elements[i];
            const rect = element.getBoundingClientRect();
            if (isVisible(element, rect)) {
                __classPrivateFieldGet(this, _HihglightOverlay_elements, "f").push({
                    ...rect,
                    x: rect.x - __classPrivateFieldGet(this, _HihglightOverlay_params, "f").offset,
                    y: rect.y - __classPrivateFieldGet(this, _HihglightOverlay_params, "f").offset,
                    width: rect.width + __classPrivateFieldGet(this, _HihglightOverlay_params, "f").offset * 2,
                    height: rect.height + __classPrivateFieldGet(this, _HihglightOverlay_params, "f").offset * 2,
                });
            }
        }
        __classPrivateFieldGet(this, _HihglightOverlay_context, "f").show();
        __classPrivateFieldGet(this, _HihglightOverlay_instances, "m", _HihglightOverlay_draw).call(this);
        __classPrivateFieldGet(this, _HihglightOverlay_mouseHandler, "f").mount();
    }
    close() {
        __classPrivateFieldGet(this, _HihglightOverlay_context, "f").hide();
        __classPrivateFieldGet(this, _HihglightOverlay_mouseHandler, "f").unmount();
    }
}
_HihglightOverlay_context = new WeakMap(), _HihglightOverlay_elements = new WeakMap(), _HihglightOverlay_params = new WeakMap(), _HihglightOverlay_cursor = new WeakMap(), _HihglightOverlay_mouseHandler = new WeakMap(), _HihglightOverlay_instances = new WeakSet(), _HihglightOverlay_draw = function _HihglightOverlay_draw() {
    const ctx = __classPrivateFieldGet(this, _HihglightOverlay_context, "f").getCtx();
    const width = __classPrivateFieldGet(this, _HihglightOverlay_context, "f").getWidth();
    const height = __classPrivateFieldGet(this, _HihglightOverlay_context, "f").getHeight();
    ctx.clearRect(0, 0, width, height);
    ctx.beginPath();
    ctx.fillStyle = `rgba(${__classPrivateFieldGet(this, _HihglightOverlay_params, "f").backDropColor.toString()})`;
    ctx.globalCompositeOperation = 'source-over';
    ctx.fillRect(0, 0, width, height);
    ctx.globalCompositeOperation = 'destination-out';
    ctx.fillStyle = 'black';
    __classPrivateFieldGet(this, _HihglightOverlay_elements, "f").forEach((element) => {
        ctx.fillRect(element.x, element.y, element.width, element.height);
    });
    ctx.stroke();
    if (__classPrivateFieldGet(this, _HihglightOverlay_params, "f").cursor.enabled) {
        ctx.arc(__classPrivateFieldGet(this, _HihglightOverlay_cursor, "f").x, __classPrivateFieldGet(this, _HihglightOverlay_cursor, "f").y, __classPrivateFieldGet(this, _HihglightOverlay_params, "f").cursor.size, 0, 2 * Math.PI);
        ctx.fill();
    }
}, _HihglightOverlay_updateCursor = function _HihglightOverlay_updateCursor(x, y) {
    __classPrivateFieldGet(this, _HihglightOverlay_cursor, "f").x = x;
    __classPrivateFieldGet(this, _HihglightOverlay_cursor, "f").y = y;
    __classPrivateFieldGet(this, _HihglightOverlay_instances, "m", _HihglightOverlay_draw).call(this);
}, _HihglightOverlay_handleClick = function _HihglightOverlay_handleClick(event) {
    switch (__classPrivateFieldGet(this, _HihglightOverlay_params, "f").close) {
        case CloseTypes.NONE:
            return;
        case CloseTypes.ALWAYS:
            return this.close();
        case CloseTypes.BACKDROP:
            const alpha = __classPrivateFieldGet(this, _HihglightOverlay_context, "f").getCtx().getImageData(event.clientX, event.clientY, 1, 1).data[3];
            if (alpha !== 0) {
                this.close();
            }
            return;
    }
};
export default HihglightOverlay;
//# sourceMappingURL=HihglightOverlay.js.map